datablock ParticleEmitterData(InflatableBoatFoamEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 2.5;
   velocityVariance = 0.8;
   ejectionOffset   = 1.0;
   thetaMin         = 80;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlayerFoamParticle";

   useEmitterColors = true;

   uiName = "Inflatable Boat Foam";
};

datablock PlayerData(InflatableBoatArmor : PlayerStandardArmor)
{
	cameraVerticalOffset = 3;
	shapefile = "./inflatableboat.dts";
	canJet = 0;
	mass = 120;
   drag = 0.02;
   density = 0.6;
   runSurfaceAngle = 1;
   jumpSurfaceAngle = 1;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxForwardCrouchSpeed = 0;
   maxSideSpeed = 0;
   maxSideCrouchSpeed = 0;
   maxStepHeight = 0;
   maxUnderwaterSideSpeed = 0;

	uiName = "Inflatable Boat";
	showEnergyBar = false;
	
   jumpForce = 0;
   jumpEnergyDrain = 10000;
   minJumpEnergy = 10000;
   jumpDelay = 127;
   minJumpSpeed = 0;
   maxJumpSpeed = 0;
	
	rideable = true;
	canRide = false;
	paintable = true;
	
   boundingBox			= vectorScale("3 3 1", 4); 
   crouchBoundingBox	= vectorScale("3 3 1", 4);
	
   lookUpLimit = 0.65;
	lookDownLimit = 0.45;
	
   numMountPoints = 4;
   mountThread[0] = "sit";
   mountThread[1] = "root";
   mountThread[2] = "sit";
   mountThread[3] = "sit";

   splashEmitter[0] = InflatableBoatFoamEmitter;
   splashEmitter[1] = InflatableBoatFoamEmitter;
   splashEmitter[2] = InflatableBoatFoamEmitter;
   
   upMaxSpeed = 1;
   upResistSpeed = 1;
   upResistFactor = 1;
   maxdamage = 200;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   useCustomPainEffects = true;
   PainHighImage = "";
   PainMidImage  = "";
   PainLowImage  = "";
   painSound     = "";
   deathSound    = "";
};

function InflatableBoatArmor::onAdd(%this, %obj)
{
   if (isObject(hvymgTurretPlayer))
   {
      %t = new AIPlayer() {
         dataBlock = hvymgTurretPlayer;
      };

      if (isObject(%t))
      {
         MissionCleanup.add(%t);
         %obj.mountObject(%t, 1);
         %obj.turret = %t;

         %t.schedule(10,"rigBoatMG");
      }
   }
}

function Player::rigBoatMG(%obj)
{
   if(%obj.dataBlock !$= hvymgTurretPlayer)
      return;

   if(!isObject(%obj))
      return;

   %parent = %obj.getObjectMount();
   if(!isObject(%parent))
      return;

   %obj.spawnBrick = %parent.spawnBrick;
   %obj.brickGroup = %parent.brickGroup;
}

function InflatableBoatArmor::onRemove(%this,%obj)
{
   if(isObject(%obj.turret))
      %obj.turret.delete();
}

function InflatableBoatArmor::onDisabled(%this, %obj, %state) 
{
   if (%obj.isDisabled() && isObject(%obj.turret))
   {
      %obj.turret.kill();
   }

   return parent::onDisabled(%this, %obj, %state);
}

function hvymgTurretPlayer::onDriverLeave(%this,%obj)
{
   if(%obj.isMounted())
      %obj.setTransform("0 0 0 0 0 0 0");
}

package InflatableBoatPackage
{
   function ShapeBase::setNodeColor(%obj,%node,%color)
   {
      Parent::setnodecolor(%obj,%node,%color);
      if(isObject(%obj.turret))
      {
         %obj.turret.setNodeColor("ALL",%color);
      }
   }
};
activatePackage(InflatableBoatPackage);